<!-- eslint-disable vue/no-unused-vars -->
<template>
  <div class="align-items-stretch d-flex flex-shrink-1 flex-grow-1 overflow-auto">
    <div class="bg-white border-right p-3 pt-4 shadow-sm">
      <locus-search-control
        :disabled="statisticsStatus === StatisticsStatus.LOADING"
        :errored="statisticsStatus === StatisticsStatus.ERROR"
        :error-message="statisticsErrorMessage"
        :filters="filters"
        style="width: 300px"
        @apply-filters="applyFilters"
        @remove-filter="removeFilter"
      />
    </div>
    <div
      class="align-self-start flex-grow-1 flex-start bg-white m-2 p-3 rounded border shadow-sm"
      style="overflow: auto"
    >
      <div v-if="searchStatus === SearchStatus.LOADING">
        <content-loader-table
          v-if="searchStatus === SearchStatus.LOADING"
          :num-rows="perPage"
          :height="perPage * 30"
        />
      </div>
      <div v-if="searchStatus === SearchStatus.ERROR">
        <b-list-group>
          <b-list-group-item variant="danger">
            <h5>Error Completing Your Search</h5>
            <p class="mb-0">
              {{ errorMessage }}
            </p>
          </b-list-group-item>
        </b-list-group>
      </div>
      <div v-if="searchStatus === SearchStatus.EMPTY">
        <b-list-group>
          <b-list-group-item variant="warning">
            <h5>Nothing Matched Your Search</h5>
            <p class="mb-0">
              Try clearing some of your filters in the search panel.
            </p>
            <p class="mb-0">
              You may also want to double-check the format of your
              coordinate string.
            </p>
          </b-list-group-item>
        </b-list-group>
      </div>
      <div v-if="searchStatus === SearchStatus.SUCCESS">
        <div class="d-flex justify-content-between align-items-baseline mb-2">
          <div>
            <base-button-icon
              v-b-modal.api-access-modal
              color="gray"
              icon="terminal"
              size="sm"
              tooltip-text="API Access"
            />
            <b-modal
              id="api-access-modal"
              size="xl"
              title="ANTARES API"
              @shown="$refs.test.refresh()"
            >
              <p class="mb-0">
                You can fetch this result set using the ANTARES Python API. Make sure that you have
                the ANTARES client installed (version v1.0 or higher):
              </p>
              <pre><code>
$ pip install antares-client
$ antares --version
antares, version v1.0.0
</code></pre>
              <p>Download or copy/paste the following script to fetch the loci from this search.</p>
              <base-editor
                ref="test"
                v-model="antaresApiScript"
                :header="true"
                filename="antares_search.py"
                read-only
              />
            </b-modal>
          </div>
          <div class="d-flex align-items-baseline">
            <div
              v-b-tooltip.hover.left.v-primary
              title="Select columns for display"
            >
              <b-dropdown
                class="mr-2"
                variant="link"
                menu-class="text-nowrap"
              >
                <template #button-content>
                  <font-awesome-icon
                    icon="columns"
                    :style="{color: 'gray'}"
                  />
                </template>
                <b-dropdown-form>
                  <b-form-checkbox-group
                    v-model="columnsEnabled"
                    :options="columnOptions"
                    stacked
                  />
                </b-dropdown-form>
              </b-dropdown>
            </div>
            <span class="mr-2">Showing {{ pageStart }}-{{ pageEnd }} of {{ lociCount }}</span>
            <b-form
              class=""
              inline
            >
              <b-form-select
                v-model="perPage"
                :options="pageOptions"
                class="mr-2 flex-shrink-1"
                size="sm"
                @change="applyPagination($event, 1)"
              />
              <b-pagination
                v-model="currentPage"
                :per-page="perPage"
                :total-rows="lociCount"
                class="m-0"
                size="sm"
                @change="applyPagination(perPage, $event)"
              />
            </b-form>
          </div>
        </div>
        <b-table
          :fields="columnsActive"
          :items="loci"
          :sort-by="sortBy"
          :sort-desc="sortDesc"
          borderless
          hover
          no-local-sorting
          small
          responsive
          @row-hovered="hovered = $event.id"
          @row-unhovered="hovered = null"
          @sort-changed="applySort"
        >
          <template #head(newestThumbnails)="data">
            Newest Thumbnails
            <span
              v-b-tooltip.hover.top.v-primary
              title="We vertically flip thumbnails from ZTF for display. Thumbnails newer than
                2022-02-13 are scaled to maximize feature resolution."
            >
              <font-awesome-icon icon="question-circle" />
            </span>
          </template>
          <template #cell()="data">
            <div v-if="isNaN(data.value)">
              {{ data.value }}
            </div>
            <div
              v-else
              class="text-right"
            >
              {{ data.value }}
            </div>
          </template>
          <template #cell(id)="data">
            <b-link :to="{ name: 'locusDetail', params: { locusId: data.value } }">
              {{ data.value }}
            </b-link>
          </template>
          <template #cell(newestThumbnails)="data">
            <div
              class="d-flex"
              :style="{'height': '50px', 'max-height': '50px'}"
            >
              <base-image
                :flip-y="true"
                :src="getThumbnailSources(data.item).science"
                :width="'50px'"
                :height="'50px'"
                class="mr-1"
              />
              <base-image
                :flip-y="true"
                :src="getThumbnailSources(data.item).template"
                :width="'50px'"
                :height="'50px'"
                class="mr-1"
              />
              <base-image
                :flip-y="true"
                :src="getThumbnailSources(data.item).difference"
                :width="'50px'"
                :height="'50px'"
                class="mr-1"
              />
            </div>
          </template>
          <template #cell(actions)="data">
            <div class="text-center">
              <div v-if="data.item.id === hovered">
                <locus-actions
                  :locus="data.item"
                  :comment="false"
                  :download="false"
                  :email="false"
                />
              </div>
              <div v-else>
                <font-awesome-icon
                  icon="ellipsis-h"
                  style="color: gray"
                />
              </div>
            </div>
          </template>
        </b-table>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable no-shadow, no-empty, camelcase,
  prefer-destructuring, @typescript-eslint/no-empty-function */
import Vue from 'vue';
import { mapGetters } from 'vuex';
import bodybuilder from 'bodybuilder';
import { BvTableCtxObject } from 'bootstrap-vue';

import { ElasticsearchFilter, Locus } from '@/common/types';
import { FETCH_LOCI, FETCH_LOCI_STATISTICS } from '@/store/actions';
import BaseButtonIcon from '@/components/BaseButtonIcon.vue';
import BaseEditor from '@/components/BaseEditor.vue';
import BaseImage from '@/components/BaseImage.vue';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';
import LocusSearchControl from '@/components/Locus/SearchControl.vue';
import LocusActions from '@/components/LocusActions.vue';

enum SearchStatus {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
  EMPTY = 'EMPTY', // Like success but no results returned
}

enum StatisticsStatus {
  LOADING = 'LOADING',
  SUCCESS = 'SUCCESS',
  ERROR = 'ERROR',
}

const DEFAULT_QUERY = {
  currentPage: 1,
  filters: [],
  perPage: 25,
  sortBy: 'properties.newest_alert_observation_time',
  sortDesc: true,
};

export default Vue.extend({
  name: 'LocusList',

  components: {
    BaseButtonIcon,
    BaseEditor,
    BaseImage,
    ContentLoaderTable,
    LocusActions,
    LocusSearchControl,
  },

  data() {
    return {
      SearchStatus,
      StatisticsStatus,
      currentPage: 1,
      errorMessage: '',
      columnsEnabled: [] as string[],
      columnsAvailable: [
        {
          key: 'id',
          label: 'ID',
          sortable: false,
        },
        {
          key: 'newestThumbnails',
          label: 'Newest Thumbnails',
        },
        {
          key: 'properties.ztf_object_id',
          label: 'ZTF ID',
          sortable: true,
        },
        {
          formatter: (value: number) => value.toFixed(2),
          key: 'ra',
          label: 'RA',
          sortable: true,
        },
        {
          formatter: (value: number) => value.toFixed(2),
          key: 'dec',
          label: 'Dec',
          sortable: true,
        },
        {
          formatter: (value: number) => value.toFixed(2),
          key: 'properties.newest_alert_magnitude',
          label: 'Latest Mag',
          sortable: true,
        },
        {
          formatter: (value: number) => value.toFixed(2),
          key: 'properties.brightest_alert_magnitude',
          label: 'Brightest Mag',
          sortable: true,
        },
        {
          key: 'properties.num_mag_values',
          label: '# Alerts',
          sortable: true,
        },
        {
          formatter: (value: number) => (<any> this).mjdToDate(value).toISOString().slice(0, 19).replace('T', ' '),
          key: 'properties.newest_alert_observation_time',
          label: 'Latest Alert',
          sortable: true,
        },
        {
          formatter: (value: number) => (<any> this).mjdToDate(value).toISOString().slice(0, 19).replace('T', ' '),
          key: 'properties.oldest_alert_observation_time',
          label: 'First Alert',
          sortable: true,
        },
        {
          key: 'actions',
          label: 'Actions',
        },
      ],
      filters: [] as ElasticsearchFilter[],
      hovered: null,
      pageOptions: [5, 10, 25],
      perPage: 25,
      sortBy: 'properties.newest_alert_observation_time',
      sortDesc: true,
      searchStatus: SearchStatus.LOADING,
      statisticsErrorMessage: '',
      statisticsStatus: StatisticsStatus.LOADING,
    };
  },

  computed: {
    ...mapGetters(['loci', 'lociCount']),

    antaresApiScript(): string {
      return `"""
A script to fetch the loci in a search query from the ANTARES API.
"""

from antares_client.search import search

QUERY = ${JSON.stringify(this.elasticsearchQuery, null, 4)}


def process_locus(locus):
    """Put your custom processing logic here."""
    print(locus.locus_id)


def main():
    for locus in search(QUERY):
        process_locus(locus)


if __name__ == "__main__":
    main()

`;
    },

    elasticsearchQuery(): any {
      return this.filters
        .reduce(
          (query, filter) => query.filter(filter.type, filter.field, filter.value),
          bodybuilder(),
        )
        .build();
    },

    columnsActive(): {[key: string]: any}[] {
      return this.columnsAvailable.filter((column) => this.columnsEnabled.includes(column.key));
    },

    columnOptions(): {[key: string]: any}[] {
      return this.columnsAvailable.map((column) => ({ text: column.label, value: column.key }));
    },

    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.lociCount ? this.lociCount : pageEnd;
    },

    /*
     * pageOffset is the starting index of the current paged result set, 0-based
     */
    pageOffset(): number {
      return (this.currentPage - 1) * this.perPage;
    },

    /*
     * pageStart is the starting index of the current paged result set, 1-based
     */
    pageStart(): number {
      return this.pageOffset + 1;
    },
  },

  watch: {
    columnsEnabled() {
      this.saveColumnsEnabled();
    },
  },

  beforeMount() {
    if (this.$route.query.query) {
      try {
        this.setQueryFromRoute();
      } catch {}
    }
  },

  mounted() {
    this.loadColumnsEnabled();
    this.fetchLoci();
    this.fetchLociStatistics();
  },

  methods: {
    getThumbnailSources(locus: Locus) {
      const { newest_thumbnails } = locus.meta;
      const thumbnails_by_type = {
        science: newest_thumbnails.find((t) => t.data.attributes.thumbnail_type === 'science'),
        template: newest_thumbnails.find((t) => t.data.attributes.thumbnail_type === 'template'),
        difference: newest_thumbnails.find((t) => t.data.attributes.thumbnail_type === 'difference'),
      };
      return {
        science: thumbnails_by_type.science ? thumbnails_by_type.science.data.attributes.src : '',
        template: thumbnails_by_type.template ? thumbnails_by_type.template.data.attributes.src : '',
        difference: thumbnails_by_type.difference ? thumbnails_by_type.difference.data.attributes.src : '',
      };
    },

    async applyFilters(newFilters: ElasticsearchFilter[]) {
      this.currentPage = 1;
      this.filters = this.filters.concat(newFilters);
      await Promise.all([this.fetchLoci(), this.fetchLociStatistics()]);
    },

    async applyPagination(limit: number, page: number) {
      this.currentPage = page;
      this.perPage = limit;
      await this.fetchLoci();
    },

    async applySort(ctx: BvTableCtxObject) {
      this.currentPage = 1;
      this.sortBy = ctx.sortBy || DEFAULT_QUERY.sortBy;
      this.sortDesc = ctx.sortDesc;
      await this.fetchLoci();
    },

    async fetchLociStatistics() {
      this.statisticsStatus = StatisticsStatus.LOADING;
      try {
        await this.$store.dispatch(FETCH_LOCI_STATISTICS, {
          query: {
            ...(this.filters.length && {
              'elasticsearch_query[locus_listing_statistic]':
                JSON.stringify(this.elasticsearchQuery),
            }),
          },
        });
        this.statisticsStatus = StatisticsStatus.SUCCESS;
      } catch (error) {
        this.statisticsStatus = StatisticsStatus.ERROR;
        this.statisticsErrorMessage = error[0];
      }
    },

    async fetchLoci() {
      this.$router.replace(
        {
          query: {
            query: JSON.stringify({
              currentPage: this.currentPage,
              filters: this.filters,
              sortBy: this.sortBy,
              sortDesc: this.sortDesc,
              perPage: this.perPage,
            }),
          },
        },
        () => {},
      );
      this.searchStatus = SearchStatus.LOADING;
      try {
        await this.$store.dispatch(FETCH_LOCI, {
          query: {
            page: {
              limit: this.perPage,
              offset: (this.currentPage - 1) * this.perPage,
            },
            ...(this.sortBy && { sort: (this.sortDesc ? '-' : '') + this.sortBy }),
            ...(this.filters.length && {
              'elasticsearch_query[locus_listing]': JSON.stringify(this.elasticsearchQuery),
            }),
          },
        });
        this.searchStatus = SearchStatus.SUCCESS;
        if (this.lociCount === 0) {
          this.searchStatus = SearchStatus.EMPTY;
        }
      } catch (error) {
        this.searchStatus = SearchStatus.ERROR;
        this.errorMessage = error[0].detail;
      }
    },

    loadColumnsEnabled() {
      const value = localStorage.getItem('locusListColumnsEnabled');
      if (value) {
        this.columnsEnabled = JSON.parse(value);
      } else {
        this.columnsEnabled = this.columnsAvailable.map((column) => column.key);
      }
    },

    saveColumnsEnabled() {
      localStorage.setItem('locusListColumnsEnabled', JSON.stringify(this.columnsEnabled));
    },

    async removeFilter(index: number) {
      this.currentPage = 1;
      this.filters.splice(index, 1);
      await Promise.all([this.fetchLoci(), this.fetchLociStatistics()]);
    },

    setQueryFromRoute() {
      const query = JSON.parse(<string> this.$route.query.query);
      this.filters = query.filters || DEFAULT_QUERY.filters;
      this.sortBy = query.sortBy || DEFAULT_QUERY.sortBy;
      this.sortDesc = query.sortDesc || DEFAULT_QUERY.sortDesc;
      this.perPage = query.perPage || DEFAULT_QUERY.perPage;
      this.currentPage = query.currentPage || DEFAULT_QUERY.currentPage;
    },

    resetQuery() {
      this.filters = DEFAULT_QUERY.filters;
      this.sortBy = DEFAULT_QUERY.sortBy;
      this.sortDesc = DEFAULT_QUERY.sortDesc;
      this.perPage = DEFAULT_QUERY.perPage;
      this.currentPage = DEFAULT_QUERY.currentPage;
    },
  },
});
</script>

<style>
  .table > tbody > tr > td {
     vertical-align: middle;
  }
</style>
